program checkoutput
  use dal
  use errorhandling

  implicit none

  type(DataSetT)               :: inDataSet
  type(TableT)                 :: inTable
  type(ColumnT)                :: inColumn(5)
  integer                      :: i,inEvents
  logical ok
  integer(kind=int16), pointer :: inRawX(:), inRawY(:), corr_X(:), corr_Y(:)
  real(kind=Double), pointer   :: time(:)


  inDataSet = dataSet("RRRR_PPPPPPOOLL_OMS00a02FAE.INT", read)
  inTable = table(inDataSet,"OMFAE1") 
  inEvents = numberofRows(inTable)

  inColumn(1) = column(inTable, "RAWX", Read)
  inRawX => int16data(inColumn(1))
  
  inColumn(2) = column(inTable, "RAWY", Read)
  inRawY => int16data(inColumn(2))
  
  inColumn(3) = column(inTable, "CORR_X", Read)
  corr_X => int16data(inColumn(3))
  
  inColumn(4) = column(inTable, "CORR_Y", Read)
  corr_Y => int16data(inColumn(4))

  inColumn(5) = column(inTable, "TIME", Read)
  time => real64data(inColumn(5))
  
  ok = .true.
  
  do i = 0, inEvents-1
     if (time(i) .lt. 0) then   
        ok = .false. 
        EXIT
     endif
  end do

  if (.not.ok) then

     call error("negTime","Negative time detected in TIME column")
     
  endif
  
  ok = .false.

  do i = 0, inEvents-1
     if (((inRawX(i)-corr_X(i)) .ne. 0.).or.((inRawY(i)-corr_Y(i)) .ne. 0.)) then
        ok = .true. 
        EXIT
     endif
  enddo

  if (.not.ok) then

     call error("notRun","difference in event positions are all zero")
     
  endif
  
  call release(inColumn(1))
  call release(inColumn(2))
  call release(inColumn(3))
  call release(inColumn(4))

  call release(inTable)
  call release(inDataSet)

end program checkoutput

